import { world, EquipmentSlot, system, ItemStack} from "@minecraft/server";

export function echoBlaster() {
    world.afterEvents.itemUse.subscribe((event) => {
        const itemStack = event.itemStack;
        if (itemStack.typeId !== "sndbx_ww:echo_blaster") return;

        // Get the player and its location
        const player = event.source;
        player.dimension.playSound("sndbx_ww.use_blaster", player.location);

    });
     world.afterEvents.projectileHitEntity.subscribe((event)=>{
            
            if (event.projectile.typeId === "sndbx_ww:echo_blaster_proj"){
                const hitPosition = event.projectile.location; // Get the position of the projectile
                const dimension = event.projectile.dimension;
                const hitEntity = event.getEntityHit().entity

                hitEntity.addEffect("slowness", 5, { amplifier: 15, showParticles: true });
                //event.dimension.playSound("item.trident.hit", hitEntity.location)
                dimension.createExplosion(hitPosition, 2, {
                    causesFire: false, // Adjust explosion properties as needed
                    breaksBlocks: false // Set to false if you don't want blocks to be destroyed
                });
                dimension.spawnParticle("sndb_ww:star_explosion", hitPosition)

                if (event.projectile.isValid()) event.projectile.remove();
                
            }
        });
        world.afterEvents.projectileHitBlock.subscribe((event)=>{
            
            if (event.projectile.typeId === "sndbx_ww:echo_blaster_proj"){
                const hitPosition = event.projectile.location; // Get the position of the projectile
                const dimension = event.projectile.dimension;
                const block = event.getBlockHit().block;
                dimension.createExplosion(hitPosition, 2, {
                    causesFire: false, // Adjust explosion properties as needed
                    breaksBlocks: false // Set to false if you don't want blocks to be destroyed
                });
                dimension.spawnParticle("sndb_ww:star_explosion", hitPosition)

                if (event.projectile.isValid()) event.projectile.remove();
                //event.dimension.playSound("item.trident.hit_ground", block.location)
            }
        })
}