import { world, system, EquipmentSlot } from "@minecraft/server";

export function wardenMace() {
    world.afterEvents.entityHitEntity.subscribe((event) => {
        
        const equipment = event.damagingEntity.getComponent('equippable')?.getEquipment(EquipmentSlot.Mainhand);
        if (!equipment) return;

        if (equipment.typeId === "sndbx_ww:warden_mace") {
            const player = event.damagingEntity;
            const hitEntity = event.hitEntity;

            if (!player || !hitEntity) return;

            // Calculate direction vector for knockback
            const directionX = hitEntity.location.x - player.location.x;
            const directionZ = hitEntity.location.z - player.location.z;

            // Calculate magnitude of the vector
            const magnitude = Math.sqrt(directionX ** 2 + directionZ ** 2);

            if (magnitude > 0) {
                // Normalize the direction vector
                const normalizedX = directionX / magnitude;
                const normalizedZ = directionZ / magnitude;

                // Apply knockback
                const horizontalStrength = 2; // Adjust horizontal strength as needed
                const verticalStrength = 0.3; // Adjust vertical strength as needed

                hitEntity.applyKnockback(normalizedX, normalizedZ, horizontalStrength, verticalStrength);
                hitEntity.addEffect("slowness", 80, { amplifier: 2, showParticles: true });
                hitEntity.dimension.playSound("sndbx_ww.use_hammer", hitEntity.location);
            }
        }
    });
}
