import { world, EquipmentSlot, system, ItemStack} from "@minecraft/server";

export function wardenSpear(){
    world.afterEvents.projectileHitEntity.subscribe((event)=>{
        if (event.projectile.typeId === "sndbx_ww:warden_spear_projectile"){
            const hitEntity = event.getEntityHit().entity
            hitEntity.setOnFire(3,true)
            event.dimension.playSound("item.trident.hit", hitEntity.location)
            
            const projectileItem = new ItemStack("sndbx_ww:warden_spear", 1);
            event.projectile.dimension.spawnItem(projectileItem, event.projectile.location)
            event.projectile.remove();
            
        }
    });
    world.afterEvents.projectileHitBlock.subscribe((event)=>{
        if (event.projectile.typeId === "sndbx_ww:warden_spear_projectile"){
            const block = event.getBlockHit().block;
            event.dimension.playSound("item.trident.hit_ground", block.location)
        }
    })
    world.afterEvents.entityHitEntity.subscribe((event)=>{
        const equipment = event.damagingEntity.getComponent('equippable')?.getEquipment(EquipmentSlot.Mainhand)
        if (!equipment) return;
        if (equipment.typeId === "sndbx_ww:warden_spear"){
            //event.hitEntity.setOnFire(5,true)
        }
    });
    world.afterEvents.itemStartUse.subscribe((event)=>{
        const itemStack = event.itemStack;
        const player = event.source;

        if (itemStack.typeId !== "sndbx_ww:warden_spear" || !player.isValid()) return;

        player.addTag('sndbx_ww_use_spear')

    });
    world.afterEvents.itemStopUse.subscribe((event)=>{
        const itemStack = event.itemStack;
        const player = event.source;
        if (!itemStack) return;
        if (itemStack.typeId !== "sndbx_ww:warden_spear" || !player.isValid()) return;
        player.dimension.playSound("sndbx_ww.warden_spear.throw", player.location)
        player.removeTag('sndbx_ww_use_spear')

    });
    system.runInterval(() => {
        const ALL_PLAYERS = world.getAllPlayers();
            ALL_PLAYERS.forEach(player => {
                if (!player.isValid()) return;
                const equipment = player.getComponent('equippable')?.getEquipment(EquipmentSlot.Mainhand)
                
                if (player.hasTag("sndbx_ww_use_spear")){
                    if (!equipment){
                        player.removeTag('sndbx_ww_use_spear')
                    } else if(equipment.typeId == "sndbx_ww:warden_spear"){
                        player.playAnimation("animation.sndbx_ww.player_spear_use")
                    }
                    
                } else {
                    player.removeTag('sndbx_ww_use_spear')
                }
            })
        }
    )
}
