import { world, system, EquipmentSlot } from "@minecraft/server";

export function wardenSword(){
    world.afterEvents.entityDie.subscribe((event)=>{
        const source = event.damageSource;
        if(!source.damagingEntity || source.damagingEntity.typeId !== "minecraft:player") return;

        const equipment = source.damagingEntity.getComponent('equippable')?.getEquipment(EquipmentSlot.Mainhand)
        if (!equipment) return;
        if (equipment.typeId === "sndbx_ww:warden_sword"){
            source.damagingEntity.addEffect("strength", 60, { amplifier: 2, showParticles: true });
            source.damagingEntity.addEffect("instant_health", 1, { amplifier: 0, showParticles: true });
        }
    })
}